
%% bare_jrnl.tex
%% V1.4a
%% 2014/09/17
%% by Michael Shell
%% see http://www.michaelshell.org/
%% for current contact information.
%%
%% This is a skeleton file demonstrating the use of IEEEtran.cls
%% (requires IEEEtran.cls version 1.8a or later) with an IEEE
%% journal paper.
%%
%% Support sites:
%% http://www.michaelshell.org/tex/ieeetran/
%% http://www.ctan.org/tex-archive/macros/latex/contrib/IEEEtran/
%% and
%% http://www.ieee.org/

%%*************************************************************************
%% Legal Notice:
%% This code is offered as-is without any warranty either expressed or
%% implied; without even the implied warranty of MERCHANTABILITY or
%% FITNESS FOR A PARTICULAR PURPOSE! 
%% User assumes all risk.
%% In no event shall IEEE or any contributor to this code be liable for
%% any damages or losses, including, but not limited to, incidental,
%% consequential, or any other damages, resulting from the use or misuse
%% of any information contained here.
%%
%% All comments are the opinions of their respective authors and are not
%% necessarily endorsed by the IEEE.
%%
%% This work is distributed under the LaTeX Project Public License (LPPL)
%% ( http://www.latex-project.org/ ) version 1.3, and may be freely used,
%% distributed and modified. A copy of the LPPL, version 1.3, is included
%% in the base LaTeX documentation of all distributions of LaTeX released
%% 2003/12/01 or later.
%% Retain all contribution notices and credits.
%% ** Modified files should be clearly indicated as such, including  **
%% ** renaming them and changing author support contact information. **
%%
%% File list of work: IEEEtran.cls, IEEEtran_HOWTO.pdf, bare_adv.tex,
%%                    bare_conf.tex, bare_jrnl.tex, bare_conf_compsoc.tex,
%%                    bare_jrnl_compsoc.tex, bare_jrnl_transmag.tex
%%*************************************************************************

\documentclass[compsoc,twocolumn,10pt,letterpaper]{IEEEtran}

%\hyphenation{op-tical net-works semi-conduc-tor}
\usepackage[cmex10]{amsmath}
\usepackage{url}
\usepackage{color}
\usepackage{graphicx}
\begin{document}
%
% paper title
% Titles are generally capitalized except for words such as a, an, and, as,
% at, but, by, for, in, nor, of, on, or, the, to and up, which are usually
% not capitalized unless they are the first or last word of the title.
% Linebreaks \\ can be used within to get better formatting as desired.
% Do not put math or special symbols in the title.
\title{Metabolic Flux Analysis in Isotope Labeling Experiments using the adjoint method}
%
%
% author names and IEEE memberships
% note positions of commas and nonbreaking spaces ( ~ ) LaTeX will not break
% a structure at a ~ so this keeps an author's name from being broken across
% two lines.
% use \thanks{} to gain access to the first footnote area
% a separate \thanks must be used for each paragraph as LaTeX2e's \thanks
% was not built to handle multiple paragraphs
%

\author{St\'ephane~Mottelet,
         Gil~Gaullier
        and~Georges~Sadaka% <-this % stops a space
\thanks{S. Mottelet  is with the Department
EA4297 TIMR, Sorbonne University, Universit\'e de technologie de Compi\`egne, rue du docteur Schweitzer, F-60203 Compi\`egne, France e-mail: stephane.mottelet@utc.fr.}% <-this % stops a space
\thanks{G. Gaullier is with the  Department EA2222 LMAC, Sorbonne University, Universit\'e de technologie de Compi\`egne.}% <-this % stops a space
\thanks{G. Sadaka is with the Department CNRS, UMR7352 LAMFA, Universit\'e de Picardie Jules Verne.}% <-this % stops a space
\thanks{Manuscript received xxxx 00, 2015; revised xxxx 00, 201x.}}

% The paper headers
\markboth{IEEE/ACM Transactions on Computational Biology and Bioinformatics,~Vol.~00, No.~0, xxxxxx~201x}%
{Mottelet \MakeLowercase{\textit{et al.}}: Sysmetab}
% The only time the second header will appear is for the odd numbered pages
% after the title page when using the twoside option.
% 
% *** Note that you probably will NOT want to include the author's ***
% *** name in the headers of peer review papers.                   ***
% You can use \ifCLASSOPTIONpeerreview for conditional compilation here if
% you desire.




% If you want to put a publisher's ID mark on the page you can do it like
% this:
%\IEEEpubid{0000--0000/00\$00.00~\copyright~2014 IEEE}
% Remember, if you use this you must call \IEEEpubidadjcol in the second
% column for its text to clear the IEEEpubid mark.


% make the title area
\maketitle

% As a general rule, do not put math, special symbols or citations
% in the abstract or keywords.
\begin{abstract}
Metabolic flux analysis (MFA) in isotope labeling experiments allows to considerably enhance the comprehension of  metabolic pathways. As the balance equations are given by hundreds of algebraic (stationary MFA) or ordinary differential equations (non-stationary MFA), improvements in the number of operations are particularly decisive to reduce the computation cost, the major bottleneck of deterministic algorithms being the computation of derivatives, particularly for non-stationary MFA. In this article, we explain how to speed up the overall identification process by using the adjoint method to compute the gradient of $\ell^2$-norm of the residual. The proposed method is compared with the usual (direct) method and shows significant improvements of the computation time. Numerical results are obtained for the central metabolic pathways of \emph{Escherichia coli} and are validated against reference software. For stationary MFA, the algorithm described in this paper have been included in the software package \texttt{sysmetab} distributed under an Open Source license at http://forge.scilab.org/index.php/p/sysmetab/.
\end{abstract}

% Note that keywords are not normally used for peerreview papers.
\begin{IEEEkeywords}
xxxxx, xxxxxx.
\end{IEEEkeywords}






% For peer review papers, you can put extra information on the cover
% page as needed:
% \ifCLASSOPTIONpeerreview
% \begin{center} \bfseries EDICS Category: 3-BBND \end{center}
% \fi
%
% For peerreview papers, this IEEEtran command inserts a page break and
% creates the second title. It will be ignored for other modes.
\IEEEpeerreviewmaketitle



\section{Introduction}
\IEEEPARstart{N}{on}-stationary MFA brings a significant qualitative and quantitative gain in the comprehension of one metabolic network~(\cite{wiechert2013NMFA}), but until the introduction of the EMU framework (\cite{young2008elementary,young2014inca}), its computational cost has prevented the development of efficient non-stationary MFA software. For example, when the cumomer framework is used, the computational cost of non-stationary MFA is tremendous, e.g. the recent software OpenMebius (\cite{openmoebius}) reports almost 8 hours to estimate the fluxes of the central metabolism of \emph{E. Coli} from non-stationary data. However, size labeling state reduction based methods are not the sole strategy to make non-stationary MFA computationally tractable~(\cite{Mottelet2012RR}). Indeed, both stationary and non-stationary MFA fit into the class of general inverse problems where measurements depend on parameters through a state equation. This class of problems can benefit of a technique improving significantly  the computation of different kinds of derivatives, namely the adjoint approach (\cite{lionsmagenes,chavent,plessix}). In the following we will show that the adjoint approach allows to considerably speed up the computation of the gradient for stationary and non stationary MFA, which makes the cumomer framework still competitive with the EMU approach.

The paper is organized as follows: in section \ref{sec:math} we introduce the mathematical structure of $^{13}\mathrm{C}$ MFA under the general form of an inverse problem involving a state equation  by finding the minimum of the associated least squares functional $J$. For this general class of problems, two different classes of algorithms are available: the usual (direct) approach and the so-called adjoint approach. In section \ref{sec:MFA}, we compare both methods to compute the gradient of $J$  in terms of mathematics and complexity. Section \ref{sec:NMFA} makes the same analysis for non-stationary MFA, first in continuous time and secondly in a time grid  by a simple discrete integration scheme. Section \ref{sec:impl} is dedicated to some implementation details about the \verb1sysmetab1 software  and section \ref{sec:num} presents numerical results obtained by \verb1sysmetab1 on a stationary and non-stationary MFA problem considering  the central metabolism of \emph{E. Coli}.  Estimated values and performances are compared with \verb1influx_s1 and \verb&13CFLux2& and a time analysis is carried out for the direct and adjoint  gradient  computation  on two versions of the same network (reduced vs. full cumomer set). For the non-stationary MFA problem, preliminary results are given for gradient  computation in terms of computational time and efficiency.

\section{Optimization model of MFA}
\label{sec:math}
$^{13}\mathrm{C}$ metabolic flux analysis aims to determine fluxes $v$, pool sizes ${m} $ (in the non-stationary case), gathered into a vector of $p$ parameters $\theta=(v,{m})$, such that experimental labeling data $y$ and other measurements $w$, e.g. input/output fluxes and pool sizes, are best fitted to their simulated values by minimizing the objective function
\begin{equation}
J(\theta) =\textstyle\frac{1}{2}\Vert g(x(\theta) ,\theta)  -y\Vert_\mathcal{Y} ^2+\textstyle\frac{1}{2}\Vert h(\theta) -w\Vert_\mathcal{W} ^2,
\label{eq:data}
\end{equation}
where $g$ and $h$ are given functions and $x(\theta) $ denotes the (possibly time dependent) $n$ labeling states of the metabolic network, implicitly defined  by the state equation
\begin{equation}
f(x,\theta) =0.
\label{eq:state}
\end{equation}  
This equation takes the form of a system of algebraic or ordinary differential equations, for stationary or non-stationary metabolic flux analysis, respectively. The notations $\|\cdot\|_\mathcal{Y} $ and $\|\cdot\|_\mathcal{W} $ are used for the norms in the space of labeling and non labeling measurements denoted by $\mathcal{Y}$ and $\mathcal{W}$, respectively. The norms above (may) model variations due to  experimental noise by the introduction of  weighting covariance matrices. Both in the stationary and non stationary case, the spaces $\mathcal{Y}$ and $\mathcal{W}$ are finite dimensional normed vector spaces, namely $y$ and $w$ can be considered as vectors collecting real measured data. %

In the following, we denote by $\Theta$ the space of admissible parameters, i.e. the space describing realistic physical parameters comprising constraints on fluxes, such as  the stoichiometric equations for fluxes. In order to find 
\begin{equation}
\hat \theta=\arg\min_{\theta\in{\Theta}} J(\theta) ,
\label{eq:opt}
\end{equation}
different optimization methods can be considered. Finding $\hat \theta$ can be performed by determining the solution of successive linearized problems, as in Gauss-Newton method (GN) with a first order Taylor expansion of $g(x(\theta) )$ with respect to $\theta$ by the computation of the sensitivity matrix $x'(\theta) $. In the non-stationary case this $n\times p$ matrix is time dependent and satisfies a system of differential equations, hence is very expensive to compute. 

In contrast, if the minimization is considered as a general non-linear optimization problem, only the gradient of $J$ has to be computed, as it is the case in the Broyden-Fletcher-Goldfarb-Shanno (BFGS) and Sequential Quadratic Problem (SQP) methods. In the 1970s the adjoint state method was developed to compute the gradient in the typical situation of control theory, where the function to minimize  depends indirectly on parameters through state variables, with a minimal cost (see \cite{lionsmagenes,chavent,plessix}). This cost is asymptotically independent of the number of parameters $p$, and is equivalent to the cost of a single state equation, while using the sensitivity matrix generates a cost proportional to $p$. %
%\subsection{Adjoint state}
%We first consider a state/parameter pair $(x,\theta) $ comprising \emph{free} variables, and the function
%$$
%\mathcal{J}(x,\theta) =\Vert g(x,\theta) -y \Vert_\mathcal{Y} ^2+\Vert h(\theta) -w\Vert_\mathcal{W} ^2.
%$$
%The state equation is taken into account as a constraint by introducing a Lagrange multiplier $\lambda$ and the function of three \emph{free} variables called Lagrangian
%\begin{equation}
%\mathcal{L}(x,p,\lambda)=\mathcal{J}(x,\theta) +(\lambda,f(x,\theta) )_X.
%\label{eq:lag}
%\end{equation}
%In \eqref{eq:lag}, $(\cdot,\cdot)_X$ is the inner product in the state space $X$. One can note that for $(x,\theta) $ satisfying~\eqref{eq:state}, i.e. when $x$ is implicitly defined, the second term in~\eqref{eq:lag} vanishes, such that
%\begin{equation}
%\forall \lambda\in X,\,{\color{blue}\mathcal{J}\left(x(\theta) ,p\right)=J(\theta) }=\mathcal{L}(x(\theta) ,p,\lambda).
%\label{eq:lagstate}
%\end{equation}
%{\color{blue} From the second equality in \eqref{eq:lagstate}, }straightforward computations using the chained rule enable to relate the derivative of $J$ and the partial derivatives of $\mathcal{L}$ and $\mathcal{J}$ by 
%\begin{align*}
%J'(\theta) =\partial_x\mathcal{L}(x(\theta) ,p,\lambda)x'(\theta) +\partial_p\mathcal{J}(x(\theta) ,\theta) \\+\left(\lambda,\partial_pf(x(\theta) ,\theta) \right)_X,
%\end{align*}
%where $\partial_x$ and $\partial_p$ denote the partial derivative with respect to $x$ and $p$, respectively; but requires the computation of $x'$. However, exploiting the introduction of the \emph{new} variable $\lambda$, one can avoid its computation by annihilating the derivative before $x'$. Thus the given choice of $\lambda$ is such that it satisfies $\partial_x\mathcal{L}(x,p,\lambda)=0$.
%
%This equation is called the \emph{adjoint equation} and the implicitly defined Lagrange multiplier is called the \emph{adjoint state} associated to the state $x$. The adjoint equation takes the abstract form
%\begin{equation}
%\left(\partial_xf(x,\theta) \right)_X^*\lambda = -{\color{blue}\nabla_x\mathcal{J}(x,\theta) }%\mathcal{J}'_x(x,\theta) ,
%\label{eq:adj}
%\end{equation}
%%
%where $(\cdot)_X^*$ denotes the adjoint of the operator with respect to the inner product in $X$ {\color{blue} and where $\nabla_x\mathcal{J}$ is the gradient vector of $\mathcal{J}$ with respect to $x$}. In the next section we will give the concrete form of this linear equation, but the computation of $J'(\theta) $ with the adjoint state can already be summarized in the following recipe:
%\begin{center}
%\textsc{Adjoint recipe}
%\end{center}
%\begin{enumerate}
%%\item Compute $x(\theta) $ such that $f(x,\theta) =0$ 
%\item Compute $\lambda(\theta) $ by solving adjoint equation (\ref{eq:adj})
%\item Compute the derivative of $J$ as 
%$$
%J'(\theta) =\partial_p\mathcal{J}(x(\theta) ,\theta) +\left(\lambda(\theta) ,\partial_pf(x(\theta) ,\theta) \right)_X.
%$$
%\end{enumerate}
%This recipe has to be compared to the usual way {\color{blue}to proceed which remains first on implicit differentiation of (\ref{eq:state}) to obtain the derivative~$x'$ and secondly on introducing this value into the derivative of $J$ obtained by applying the chained rule to the first equality in~\eqref{eq:lagstate}.}
%%by applying the chained rule to 
%% with respect to $p$ to express $x'$:
%\begin{center}
%\textsc{Direct recipe}
%\end{center}\begin{enumerate}
%%\item Compute $x(\theta) $ such that $f(x,\theta) =0$
%\item Compute $x'(\theta) $ such that $\partial_xf(x(\theta) ,\theta) x'=-\partial_pf(x(\theta) ,\theta) $
%\item Compute the derivative of $J$ as 
%$$
%J'(\theta) =\partial_p\mathcal{J}(x(\theta) ,\theta) +\partial_x\mathcal{J}(x(\theta) ,\theta) x'(\theta) .
%$$
%\end{enumerate}
%Both recipes are applied after having solved the state equation to express the implicit dependency of $x$ on $p$. From a computational point of view, steps 2 has the same cost in both approaches. The crucial difference resides in step 1, which leads to solve $p$ linear problems in the direct recipe, while it requires solving only one linear problem in the adjoint recipe.
%
%
%


\section{Stationary MFA}
\label{sec:MFA}
Thanks to the cumomer fraction variables~$x=(x_1,\ldots,x_{N})$ model introduced in~\cite{wiechert1}, the structure of balance equations in stationary MFA is given by a cascade  of linear algebraic equations. If we denote by $x_k$ the vector of weight $k$ cumomer fractions,  $x_k^{\leftarrow}$ the vector of weight $k$ input cumomers and $x_{<k}$, $x_{\leq k}$ the sequences $(x_i)_{i<k}$ and $(x_i)_{i\leq k}$, respectively; then the state equation~\eqref{eq:state} can be written as%by annihilating the $N$ functions
\begin{equation}
f_k(v,x_{\leq k},x_k^{\leftarrow})=0,\quad 1\leq k\leq N,
%\tag{ST}
\label{eq:cascade}
\end{equation}
where the function $f_k$ is affine with respect to $x_k$ as
\begin{equation*}
f_k(v,x_{\leq k},x_{\leq k}^{\leftarrow})=A_k(v)x_k+b_k(v,x_{<k},x_{\leq k}^{\leftarrow}),\,
\end{equation*}
the  matrix $A_k$ and vector $b_k$ being determined by the structure of the metabolic network under consideration. The forward cascade structure of \eqref{eq:cascade} allows to successively obtain $x_1$, $x_2$,\dots,$x_N$ by solving at each step a system of linear equations. For sake of conciseness, we do not consider the terms which explicitly depend on $\theta$ in \eqref{eq:data} but only labeling measurements. In this case measurements linearly depend on the state variable so that the functional to minimize is of the form 
$$J(v)=\textstyle\frac{1}{2}\Vert Cx(v)-y\Vert^2,$$
for a given matrix $C=(C_1,\dots,C_N)$ depending on the measurement model.
%
\subsection{Direct approach}
%
For a given flux vector $v$, we first need to solve the state equation, which provides the cumomer vector $x(v)$. Then, the sequence of derivatives $(x'_k)_{1\leq k\leq N}$ is computed by solving each step of the forward cascade (the sum in the second row vanishes for $k=1$)
\begin{equation}
\left.
\begin{split}\label{eq:jac}
A_k(v)x_k'=&-\partial_vf_k(v,x_{\leq k},x_{\leq k}^{\leftarrow})\\
+&\textstyle\sum_{i<k}\partial_{x_i}b_k(v,x_{< k},x_{\leq k}^{\leftarrow})x_i',\;k\geq 1,\end{split}
\right.
%\tag{DIR1}
\end{equation}
which is obtained by implicit differentiation of \eqref{eq:cascade} with respect to~$v$. Finally, the gradient of $J$ is computed as
\begin{equation}
\nabla J(v)=\sum_{k=1}^N x'_k(v)^\top C_k^\top(Cx(v)-y) ,
%\tag{DIR2}
\label{eq:fwdgrad}
\end{equation}
where the symbol $^\top$ denotes vector and matrix transposition.
%
\subsection{Adjoint approach}
%{\color{red} We can notice that the right hand side of \eqref{eq:cascade} only depends on cumomer fractions  with weight lower than~$k$, which shows the cascade structure of the balance equations: solving~\eqref{eq:cascade} for $k=1$ enables to determine $x_1$, which enters into the vector $^1\!b$ of~\eqref{eq:cascade} for $k=1$, which enables to determine~$^1\!x$, etc.}
The adjoint approach needs to define the Lagrangian functional
\begin{align*}
\mathcal{L}(x,v,\lambda)&= \textstyle\frac{1}{2}\Vert Cx-y\Vert^2 + \sum_{k=1}^N \lambda_k^\top f_k(v,x_{\leq k},x_{\leq k}^{\leftarrow}),
\end{align*}
where $\lambda=(\lambda_k)_{1\leq k\leq N}$ is the sequence of adjoint variables. Expanding the adjoint equation $\partial_x\mathcal{L}(x,v,\lambda)=0$ (see \cite{plessix}) leads to the backward cascade (the sum vanishes for $k=N$)
\begin{equation}
\left.
\begin{split}
\label{eq:adjcascade}
A^\top_k(v) \lambda_k=&\, C_k^\top (Cx-y)\\
-&\textstyle\sum_{i>k}  \partial_{x_k}b_i(v,x_{<i},x_{\leq i}^{\leftarrow})^\top\lambda_i,\;k \leq N.\\[2mm]\end{split}
\right.
%\tag{ADJ1}
\end{equation}
For a given $v$, equations \eqref{eq:adjcascade} are solved backward, once the  cumomer vector $x(v)$ has been computed from \eqref{eq:cascade}. This procedure provides  successively $\lambda_N,\lambda_{N-1},\dots,\lambda_1$.
%
%In contrast to the state equation, the \emph{adjoint cascade} involves the values of $\lambda_i$ of indices greater than $k$, i.e. the vector  $\lambda_{>k}$ comprising the sequence $(\lambda_i)_{i>k}$. As the consequence, \eqref{eq:adjcascade} is solved by the following backward scheme: from $\lambda_n$ satisfying $A_n(v)^\top \lambda_n=C_n^\top (Cx-y)$, iterate the following procedure when $\lambda_i$ are supposed to be known for $i>k$
%\begin{itemize}
%\item Build the vector $\mathfrak{b}_k(v,x,\lambda_{>k})$ of the right hand side of \eqref{eq:adjcascade}
%\item Solve \eqref{eq:cascade}, which provides $\lambda_k$ such that the vector $\lambda_{>k-1}$ can be supposed to be known
%\end{itemize}
Then, the gradient $\nabla J$ can be obtained by the solutions of the $N$ previous linear systems as follows
\begin{equation}
\nabla J(v)=\sum_{k=1}^N  {\partial_v f_k}(v,x_{\leq k},x_{\leq k}^{\leftarrow})^\top \lambda_k.
%\tag{ADJ2}
\label{eq:adjgrad}
\end{equation}
%
Moreover, the adjoint approach can be used to compute the derivative of any function of $x$ with respect to $v$ without needing the computation of $x'(v)$, as the output sensitivity matrix  $S(v)=Cx'(v)$ which permits the computation of confidence intervals for the estimated parameters. This matrix is also used at each iteration of the optimization method to compute the  descent direction when a Gauss-Newton type algorithm is used (see \cite{influxs}). In both usages, the adjoint approach enables to compute $S(v)$  as a fraction $n_y/n$ of the usual cost, where $n_y$ is the number of measurements and $n$ the size of cumomer vector $x$.


\subsection{Computational comparison}
Both approaches involve identical tasks in the computation of $\nabla J(v)$, namely the computation of the state $x(v)$. This requires factorizing the matrices $A_k(v)$ and the computation of the derivatives $ {\partial_v f_k}$ and $\partial_{x_i}b_k$ for $i<k$. In fact, the crucial difference lies in the two remaining equations: for a given~$k$, equation~\eqref{eq:jac} requires solving a linear system where the right-hand side is a matrix with $p$ columns, while the right-hand side in equation~\eqref{eq:adjcascade} is a (single) column vector. Moreover, carrying out a subsequent analysis of equations \eqref{eq:fwdgrad} and \eqref{eq:adjgrad} enable to point that, even if it involves identical elementary operations, the computational cost of equation~\eqref{eq:adjgrad}  differ from~\eqref{eq:fwdgrad}  by the sparsity of ~${\partial_v f_k}$ contrary  to~ $x'_k$ which is full. Even it is negligible for small metabolic networks, our numerical results show that the larger the network is, the more the computational cost is improved significantly. 

For non-stationary MFA, as it will be seen in the next section, the improvements due to the adjoint approach are of the same magnitude. But, since the problem is time dependent, the overall computational cost increases considerably, making the adjoint approach essential to make the problem tractable.
%
\section{Non-stationary MFA}
\label{sec:NMFA}
In non-stationary MFA, the balance equations are modeled by a cascade of ordinary differential equations given for $1\leq k \leq N$~by 
\begin{equation}
\left\{
\begin{split}
x_k(0)&=0,\\
X_k({m} ) \frac{d}{dt} x_k(t)&=f_k(v,x(t),x_k^{\leftarrow})  ,\,t\in]0,T].
\end{split}
\label{eq:timecasc}
\right.
\end{equation}
In order to simplify the presentation we will consider that the pool sizes are known. We consider that label measurements $y_j$ are done at times $\tau_1<\dots<\tau_M$, where $0<\tau_1$ and $\tau_M<T$, so that the functional to minimize is given by 
$$J(v)=\frac{1}{2}\sum_{j=1}^{M}\Vert Cx(\tau_j;v)-y_j\Vert^2,$$
where  $x(\tau_j;v)$ is the solution of \eqref{eq:timecasc} at time $\tau_j$.

As the cumomer fractions $x_k$ are time dependent, the space $X$ of the labeling states is not a finite dimensional vector space, as it was the case in stationary MFA, but is now the (infinite dimensional) functional space $L^2([0;T])$ given by square-integrable functions. The inner product $(\cdot,\cdot)_X$ in $X$ is the usual inner product in $L^2([0;T])$, i.e. $(\phi,\psi)_X=\int_0^T \phi(t)^\top\psi(t) dt$.

\subsection{Direct approach}
As in the stationary case, the direct approach is based on the calculation of the partial derivative $x_k'$ with respect to the flux $v$.
When the sequence $(x_k')_{1\leq k\leq N}$ is time dependent, this approach involves a cascade of ordinary differential equations (ODE) 
\begin{equation}
\left.
\begin{split}
%X_1({m} ) \frac{d}{dt} x_1'=&\partial_v f_1(v,x_1,x_1^{\leftarrow})+A_1(v)x_1',\\
X_k({m} ) \frac{d}{dt} x_k'=&\partial_v f_k(v,x_{\leq k},x_{\leq k}^{\leftarrow})+A_k(v)x_k'\\
&+\textstyle\sum_{i<k}  \partial_{x_i}f_k(v,x_{\leq i},x_{\leq i}^{\leftarrow}) x_i',
\end{split}
\right.
\label{eq:timedirect}
\end{equation}
for $1\leq k\leq N$, obtained by the differentiation of \eqref{eq:timecasc} with respect to the flux parameter $v$. In \eqref{eq:timedirect}, the sum in the second row vanishes for $k=1$ and $\frac{d}{dt} x_k'$ denotes the time derivative of $x_k'$. The initial condition related to \eqref{eq:timedirect} is given, for all $k$ such that $1\leq k\leq N$, by $x_k'(0)=0$. The gradient of $J$ reads
\begin{equation}
\nabla J(v)=\sum_{j=1}^M\sum_{k=1}^N x'_k(\tau_j;v)^\top C_k^\top(Cx(\tau_j;v)-y_j) .
\label{eq:timefwdgrad}
\end{equation}


\subsection{Adjoint approach}
In the adjoint approach, the $N$ ODEs \eqref{eq:timecasc} are incorporated into a Lagrangian functional as follows
\begin{align*}
\mathcal{L}(x,p,\lambda)&=\textstyle\frac{1}{2}\sum_{j=1}^M\left\Vert Cx(\tau_j)-y_j\right\Vert^2+\\
+\sum_{k=1}^N&\int_0^T \lambda_k^\top(t)\left(f_k(v,x_{\leq k}(t),x_{\leq k}^{\leftarrow})-X_k({m} ) \textstyle\frac{d}{dt} x_k(t)\right)\,dt
\end{align*}
The adjoint equation is obtained by expanding $\partial_x\mathcal{L}(x,p,\lambda)=0$ which leads to the following backward in time ODE cascade 
\begin{equation}
\left.
\begin{split}
%X_N({m} ) \frac{d}{dt} \lambda_N&=A_N(v)^\top \lambda_N,\\
X_k({m}) \frac{d}{dt}\lambda_k&=A_k(v)^\top \lambda_k\\
-&\textstyle\sum_{i>k} \partial_{x_k}b_i(v,x_{<i},x_{\leq i}^{\leftarrow})^\top\lambda_i,
\end{split}
\right.
\label{eq:timeadj}
\end{equation}
for $1\leq k\leq N$, where the second row vanishes for $k=N$ and the equalities read for $t\in[0,T[\setminus \{\tau_j\}_{1\leq j \leq M}$. The final condition is given for each~$k$ by $\lambda_k(T)=0$ and the following $j$ step conditions
\begin{equation}
X_k({m})[\lambda_k(\tau_j^+)-\lambda_k(\tau_j^-)]=C_k^\top (Cx(\tau_j)-y_j),
\label{eq:iniadj}
\end{equation}
occur for $j=1\dots M$. 
Considering \eqref{eq:timeadj}-\eqref{eq:iniadj} determines the functions $\lambda_k(t)$ which enter into the gradient of $J$ (with respect to $v$) as follows
\begin{equation}
\nabla J(v)=\sum_{k=1}^N \int_0^T\partial_v f_k(v,x_{\leq k}(t),x_{\leq k}^{\leftarrow})^\top \lambda_k\,dt.
\label{eq:timeadjgrad}
\end{equation}
\subsection{Discrete time schemes}
As in stationary MFA, both the direct and the adjoint approaches in non-stationary MFA require the computation of $x(T;v)$, which can be performed  efficiently by using discrete schemes. From a time grid $t_n=nh$,  with $h=T/N_T$ ($N_T+1$ denoting the total number of points sampling the interval $[0;T]$), discrete schemes are based on approximating the integral of the right hand side of \eqref{eq:timecasc} over $[t_n;t_{n+1}]$. For sake of simplicity we will consider the implicit Euler scheme but a similar approach can be done for schemes having a greater order and also taking into account the possible stiffness of the state equation, such as the implicit trapezoidal rule (\cite{Mottelet2012RR}) or implicit Runge-Kutta schemes (\cite{sandu}).

Denoting the approximations $x_k^n\simeq x_k(t_n)$ and $x_{\leq k}^n\simeq x_{\leq k}(t_n)$, the implicit Euler scheme gives the following  discrete version of~\eqref{eq:timecasc}
\begin{equation}
\left\{
\begin{split}
x_k^0&=0,\\
X_k({m}) \left(x_k^{n+1}-x_k^n\right)&=h f_k(v,x_ {\leq k}^{n+1},x_{\leq k}^\leftarrow)\,
\end{split}
\label{eq:discrcasc}
%\tag{ST\_ns}
\right.
\end{equation}
where the second row has to be considered for $0\leq n<N_T$, and the objective function is given by
$$J(v)=\textstyle\frac{1}{2}\sum_{j=1}^M\Vert Cx^{n(j)} -y_j  \Vert$$
where $t_{n(j)}=\tau_j$, i.e. each measurement time corresponds to a sampling time of the discrete scheme.


In the direct approach, implicit derivation of scheme \eqref{eq:discrcasc} with respect to $v$ and application of the Euler scheme to the continuous time equation \eqref{eq:timedirect} provides the same discrete scheme to approximate the derivatives $x'_k$ at sampling points $t_n$:
\begin{equation}
\left.
\begin{split}
%X_1({m} )(x_1'^{\,n+1}-x_1'^{\,n})=&\tau\partial_v f_1(v,x_1^{n+1},x_1^{\leftarrow})+\tau A_1(v)x_1'^{\,n+1},\\
X_k({m} ) (x_k'^{\,n+1}-x_k'^{\,n})=&h A_k(v)x_k'^{\,n+1}+h\partial_v f_k(v,x_{\leq k}^{n+1},x_{\leq k}^{\leftarrow})\\
+h&\textstyle\sum_{i<k}  \partial_{x_i}f_k(v,x_{\leq i}^{n+1},x_{\leq i}^{\leftarrow}) x_i'^{\,n+1}\\[2mm]
\end{split}
\right.
%\tag{DIR1\_ns}
\label{eq:discrdirect}
\end{equation}
combined with the initial condition $x_k'^{\,0}=0$ and $x_k'^{\,0}=0$ for $k=1\dots N$. From the time  state variable sequence and the time state derivative sequence, the gradient is obtained as
\begin{equation}
\nabla J(v)=\sum_{j=1}^M\sum_{k=1}^N (x_k'^{\,n(j)})^\top C_k^\top(Cx^{n(j)}-y_j) .
%\tag{DIR2\_ns}
\label{eq:discrdirectgrad}
\end{equation}
 In the adjoint approach, the chosen discrete scheme generates $N_T$ equalities incorporated into the Lagrangian functional by  $N_T$ discrete Lagrange multiplier $(\lambda_k^n)_{0\leq n<N_T}$. Considering all weight $k$ cumomer fractions leads to the following discrete version of the Lagrangian functional associated to \eqref{eq:discrcasc}
\begin{equation}
\begin{split}
&\mathcal{L}(x,p,\lambda)=\textstyle\frac{1}{2}\sum_{j=1}^M\left\Vert Cx^{n(j)}-y_j\right\Vert^2+\\
&\sum_{k=1}^N\sum_{n=0}^{N_T-1}(\lambda_k^n)^\top\left(h f_k(v,x_ {\leq k}^{n+1},x_{\leq k}^\leftarrow)-X_k({m} ) \left(x_k^{n+1}-x_k^n\right)\right).
\end{split}
\label{eq:discrlagr}
\end{equation}

We emphasize that establishing  the discrete version of \eqref{eq:timeadj} has to be performed by deriving  the discrete Lagrangian \eqref{eq:discrlagr} and can not be carried out by simply choosing discrete schemes associated to  \eqref{eq:timeadj} and \eqref{eq:timeadjgrad}. Indeed, the discrete adjoint equation is completely determined once a discrete scheme is chosen for the state equation. For the Euler scheme \eqref{eq:discrcasc} and the Lagrangian \eqref{eq:discrlagr} the discrete adjoint scheme is thus given for $n=1\dots N_T-1$ by 
\begin{equation*}
\left.
\begin{split}
&X_k({m})({\lambda_k^n-\lambda_k^{n-1}})= h A_k(v)^\top \lambda_k^{n-1}\\
&-h\sum_{i>k} \partial_{x_k}b_i(v,x_{<i}^n,x_{\leq i}^{\leftarrow})^\top\lambda_i^{n-1}+\delta_n,
\end{split}
\right.
\label{eq:discradjoint}
%\tag{ADJ1\_ns}
\end{equation*}
with final condition $\lambda_k^{N_T-1}=0$ and
$$\delta_n=\left\{
\begin{array}{rl}
C_k^\top (Cx^{n}-y_j),&\mbox{if } n=n(j),\\
0,&\mbox{otherwise},
\end{array}
\right.$$
and determines~$(\lambda_k^n)_{0\leq n<N_T}$ for each weight $k$. The gradient of $J$ at $v$ is finally given by
\begin{equation}
\nabla J(v)=h\sum_{k=1}^N \sum_{n=0}^{N_T-1}\partial_v f_k(v,x^{n+1}_{\leq k},x_{\leq k}^{\leftarrow})^\top \lambda_k^n.
%\tag{ADJ2\_ns}
\label{eq:discradjgrad}
\end{equation}

\subsection{Computational comparison}
As in the stationary case, the computation of $\nabla J(v)$ in direct and adjoint approaches involves the computation of the time dependent state $x$ and the associated cost will depend on the chosen discrete scheme. The difference still lies in the cascades \eqref{eq:timedirect} and \eqref{eq:timeadj} involving $N$ differential equations with $p$ column matrices in the direct case, while 1-column vectors enter into the left hand side of \eqref{eq:timeadj} in the adjoint approach. Hence, identical gain as in the stationary case is at least expected.

Another interesting aspect of the adjoint approach appears when the pool sizes are also unknown: in the direct approach equation \eqref{eq:timedirect} has to be implicitly derived with respect to $m$, which leads to a more complex system to express and to solve than \eqref{eq:timedirect}. In contrast, the structure of the system \eqref{eq:timeadj} is independent of the actual unknown parameters in the adjoint approach. The particular constant choice we developed in this description only change the last step \eqref{eq:timeadjgrad} in the gradient computation. 
%
\section{Implementation}
\label{sec:impl}
\subsection{Stationnay MFA}
Metabolic network input data description, carbon atom transition map (in reactions) and experimental measurements are available in a plain text XML file as  the Flux Markup Language (http://www.13cflux.net/fluxml) format developed for the \texttt{13CFlux2} software ({http://www.13cflux.net/13cflux2}) requests (\cite{13CFLUX2}). Conforming to FTBL format input files are also supported and automatically converted to the FML format, as the previous version of the \texttt{13CFlux} software was designed for. The \verb1sysmetab1 software parses this file to generate automatically a specific program to the network under consideration in the Scilab language (http://www.scilab.org) (\cite{scilabbook}) for flux identification. Before generation the cumomer network is systematically reduced by using the backward tracing method (\cite{antoniewicz2007}).

Another innovative aspect of the software, besides the adjoint approach,
remain in the choice of the generating code technique: from the original FML file, only XSL transformations (http://www.w3.org/TR/xslt) are used to generate the Scilab program. These  transformations are described in XSL stylesheets, written in another XML dialect. XSL is very different from the 
typical programming languages commonly used today because it is a declarative (as opposed to imperative) language. An important aspect of this choice is that the XSL stylesheets are very explicit, human readable, and easy to debug and maintain. The generation of the program is done in several steps, the last being devoted to the XML program description transformation into the actual Scilab program. This last transformation can be easily adapted to other script languages such as Matlab (http:/www.mathworks.com) or Julia (http://julialang.org).

The generated program uses all the possibilities given by Scilab to improve the speed of calculations: vectorization and sparse matrices for the assembly and for the state and adjoint state calculation are exploited with the UMFPACK multi-frontal LU factorization (\cite{davis:umfpack}). The optimization phase is performed with the Feasible Sequential Quadratic Programming (FSQP) algorithm  (\cite{fsqp}) which is available as a Scilab module. Linearized statistics or Monte-Carlo simulations can be used to make confidence intervals on estimated fluxes available. When the latter method is used, Scilab allows parallel execution of the optimization algorithm on a multi-core architecture. After execution of the generated program, the complete results of the optimization are collected in a plain text XML file conforming to the Forward Simulation Markup Language (http://www.13cflux.net/fwdsim) developed for the \texttt{13CFlux2} software. This file can be easily processed with XSL transformations in order to convert it to other file formats.

The \verb1sysmetab1 software is launched from a command-line tool and is available for Linux and MacOSX platforms. It is available as a Scilab ATOMS module at http://forge.scilab.org/index.php/p/sysmetab/ under Open Source license. However, a special agreement should be asked for FSQP: as this library is dedicated to research and development, agreement with the authors has to be submitted for other use.

\subsection{Non-stationary MFA}
In the next section we will give provisional results comparing the computation time of $\nabla J(v)$ with the direct and the adjoint approach for a metabolic network where the pool sizes are known and simulated measurements are considered. However, at the time of writing this paper the available version of \verb1sysmetab1 does not handle non-stationary MFA because this feature is still under construction. In particular an optimized forward and adjoint high-order ODE solver taking into account sparsity of matrices is currently under development. However, even though the numerical results of section \ref{num:nonstat} have been obtained with an implicit direct and adjoint Euler scheme, they already demonstrate the advantages and efficiency of the adjoint approach.
\section{Numerical results}
\label{sec:num}
\subsection{Stationary MFA}
\label{sec:num-mfa}
\begin{table}[!htb]
\caption{Comparison of estimated free fluxes values, final cost and calculation times  between \texttt{influx\_s}, \texttt{sysmetab} and \texttt{13CFlux2}. \label{tab:compstat}}
{\begin{tabular}{llll}
\textbf{Software}	& \texttt{influx\_s}	& \texttt{sysmetab}	& \texttt{13CFlux2}\\\hline\\
{Free fluxes} \\\hline
Glucupt\_1.n	& 0.80651338 & 0.80651342	& 0.80634528\\
gnd.n	      & 0.14223479 & 0.14223488 & 0.13804339\\
out\_Ac.n   & 0.21300001 & 0.21300000 & 0.21299847\\
pyk.n       & 1.54425507 & 1.54425504 & 1.52116680\\
zwf.n       & 0.14233479 & 0.14233488 & 0.14145512\\
ald.x       & 0.72497650 & 0.72497526 & 0.89824047\\
eno.x      & 999 & 999 & 98486.1688\\
fum\_a.x    & 0.43136935 & 0.43135328 & 0.40973977\\
ppc.x       & 0.17317925 & 0.17317878 & 0.17122549\\ 
ta.x        & 0.56653403 & 0.56653486 & 0.56756226\\
tk1.x       & 0.17878863 & 0.17878854 & 0.17125450\\
tk2.x & 0 & 0 & 0.00213\\
%\\
%{Scaling factors}\\\hline
%Fru6P & 1.01147795 & 1.01147827 & 1.01134254\\
%FruBP & 0.97055960 & 0.97055942 & 0.97132927\\
%Glc6P & 1.01355487 & 1.01355506& 1.01352638\\
%Gnt6P & 1.01203818 & 1.01203816 & 1.01199340\\
%ICit & 0.95619862 & 0.95619862 & 0.95713176\\
%PEP & 0.99770064 & 0.99770031 & 0.99717006\\
%PGA & 1.00476904 & 1.00476926 & 1.00426511\\
%Rib5P & 0.99299023 & 0.99299017 & 0.99349304\\
%Suc & 1.15931584 & 1.15931497 & 1.16039214\\
\\{Final cost}\\\hline
&61.5141593 &	61.5141593 & 62.0877059\\
\\
{Calc. time (s)}\\\hline
Optimization & $1.03$ & {\color{blue}0.39} & $-$\\
Total & 7.4 & {\color{blue}12.8}  & 78\\
\end{tabular}}{}
\end{table}
Before comparing the adjoint and the direct approach in \verb1sysmetab1 we first consider its validation with literature data. In this purpose, the central metabolism of \emph{E. Coli}, described in \cite{millard2014sampling} and provided in the network examples of the distribution of \verb1influx_s1,  is considered. The experimental data consists in mass spectrometry measurements of intermediate metabolites Fru6P, FruBP, Glc6P, ICit, PEP, PGA, Rib5P, Suc and Acetate extracellular flux. The provided \verb1e_coli.ftbl1 file has been processed in \verb1influx_s1 with \verb1--TIMEIT1 options. After conversion to the FML format by using the command \verb1ftbl2fml1 from 13CFlux2, it has been processed first with the last version of the software with default option and then in \verb1sysmetab1 with options \verb$--reg=0 --regphi=0$ in order to turn off the regularization of the cost function and of the transformation from the exchange/network to forward/backward fluxes. Table~\ref{tab:compstat} presents the results obtained on a Linux server hosting two ten-core Xeon E5-2660 v2 (2.20 GHz) processors. They mention the value of optimization variables, namely free fluxes (exchange fluxes given by \texttt{influx\_s} have been converted from normalized $[0,1[$ values to $[0,+\infty[$ interval)), the final value of the cost function $J(v)$ and the computation time.

The \verb1sysmetab1 software described in this paper terminated successfully with 64 iterations and a final projected gradient norm of {\color{blue}$4.84 10^{-10}$}. As the exchange flux eno.x is nearly non identifiable, the default upper bound his reached by \verb1sysmetab1 and \verb1influx_s1. We have tried to add the constraint explicitly in the FML file before running \verb$13CFlux2$ but the optimization stopped with a very large value of the cost function. 

Although \verb1influx_s1 appears  to be the fastest in terms of total computation time, if the sole optimization time is considered, \verb1sysmetab1 appears to be more efficient. When the code has to be generated only once and multiple optimizations have to be done, typically when the Monte-Carlo method is used to estimate the standard deviation of identified fluxes, then \verb1sysmetab1 is much faster. For example, a Monte-Carlo estimation with 1000 samples using all available cores of the processors took {\color{blue}29} seconds for \verb1sysmetab1 and 120 seconds for \verb1influx_s1.

We  now focus on the comparison between the direct and the adjoint approach for the computation of the gradient. By considering the same metabolic network, Table \ref{tab:ratios} compares the average computation time from steps \eqref{eq:jac}-\eqref{eq:fwdgrad} of the direct approach with steps \eqref{eq:adjcascade}-\eqref{eq:adjgrad}  of the adjoint one.
Computation time needed to solve the state equation are mentioned in order to compute the overall time ratio between the two approaches. In Table \ref{tab:ratios}, time results from the optimally reduced network comprising 1069 cumomers are opposed to those obtained by the original former 5455 cumomer full network.

As the number of cumomers in the fully network differs from the reduced network almost up to a factor 5, the related time needed to compute the state derivative raises. In the direct approach, the contribution of the portion of this step into the overall time becomes larger up to increase the total ratio near 7.5. In contrast, this portion is reduced in the adjoint approach, the main contribution being supported by solving the state equation. By showing how the overall time is distributed, Table \ref{tab:ratios} makes clear the differences between both approaches and demonstrates the efficiency of the adjoint computation compared to the direct one. 
\begin{table}[!tpb]
\caption{\texttt{sysmetab} direct vs. adjoint computation times and ratios for the reduced and full Ecoli network. \label{tab:ratios}}
\begin{tabular}{llll}
 & Direct & Adjoint & Ratio\\
 \hline\\
Reduced network\\
 \hline
State computation \eqref{eq:cascade} & {\color{blue}1.5} & {\color{blue}1.5}& {\color{blue}1}\\
Cascade \eqref{eq:jac} vs. \eqref{eq:adjcascade} & {\color{blue}6}&  {\color{blue}0.35} & {\color{blue}17.5}\\
Gradient assembly \eqref{eq:fwdgrad} vs. \eqref{eq:adjgrad}   & {\color{blue}0.9}& {\color{blue}0.05} & {\color{blue}17.2}\\
Total & {\color{blue}8.4} & {\color{blue}1.9} & {\color{blue}4.47}\\
\\Full network\\
 \hline
State computation  \eqref{eq:cascade} & {\color{blue}3.5} & {\color{blue}3.5} & {\color{blue}1} \\
Cascade  \eqref{eq:jac} vs. \eqref{eq:adjcascade} & {\color{blue}47.2} &  {\color{blue}1.5}  & {\color{blue}31} \\
Gradient assembly \eqref{eq:fwdgrad} vs. \eqref{eq:adjgrad}   & {\color{blue}4.2} & {\color{blue}0.2}  & {\color{blue}19} \\
Total & {\color{blue}55} & {\color{blue}5.2}  & {\color{blue}10.6} \\

\hline\\
\scriptsize{Unit time=$10^{-3}$  s.}
\end{tabular}
\end{table}

\subsection{Non-stationary MFA}
\label{num:nonstat}
Making the same hypothesis as in stationary MFA, i.e. pool sizes are supposed to be known, constant, equal to one and no scaling factor are considered, we first generate simulated time dependent labeling state measurements related to the central metabolism of \emph{E.~Coli}. Estimated free flux values obtained from time free labeling state data inversion, combined with a (unconditionally stable) implicit Euler  scheme are used. Setting the final time $T$ to $6000$ and splitting the interval $[0;T[$ into $1000$ regular sub-intervals guarantee the labeling state to reach the stationary state.

%, as shows Figure~\ref{fig:data}. In Figure~\ref{fig:data}, every 231 weight $1$ cumomer fraction time dependent evolution is presented.

%\begin{figure}[!tpb]%figure1
%\centerline{\includegraphics[scale=0.4,angle=90]{weight1}}
%\caption{Weight $1$ cumomer fration time evolution.}\label{fig:data}
%\end{figure}

From these time dependent data, we apply the same computational time analysis as in the case of stationary MFA by reporting the time distribution of the different steps of the gradient computation: state computation, cascade computation and gradient assembly, namely \eqref{eq:discrcasc}, \eqref{eq:discrdirect}, \eqref{eq:discrdirectgrad} for the  time dependent direct approach and \eqref{eq:discrcasc}, \eqref{eq:discradjoint}, \eqref{eq:discradjgrad} the time dependent adjoint  approach, respectively. 
%Each step from the direct method  is compared with the adjoint one in terms of required time.

For the reduced \emph{E. Coli} network, associated computational times are presented in Table~\ref{tab:nonstat}. As expected, Table~\ref{tab:nonstat} shows that the time required to compute the state derivative by the direct method (see row 2) is much larger than just multiplying  the stationary cascade cost (see the second row of Table~\ref{tab:ratios}) by the overall number of points comprising the time grid. Indeed, 2 thousand times more than the cost of the stationary (direct) cascade is required to perform the state derivative cascade in the non stationary case. The associated ratio between the direct approach and the adjoint approach achieve more than 60, which demonstrates the efficiency of the adjoint method.

As the gradient assembly in the adjoint approach is not computationally optimized at the present time, the overall gain yields a total ratio of 18. One can even notice that this value is significantly better than those obtained in the stationary case: the adjoint approach benefits from the non stationary case, while the direct gradient computation appears to be  severely time consuming, as expected.

%Applying a linear regression on a series of required times to compute the gradient by adding the three steps presented in Table~\eqref{tab:nonstat} shows that the coefficient  of the slope related to the adjoint approach is about 0.7, while it almost reaches the value of 13 by the direct approach.
\begin{table}[!tpb]
\caption{Direct vs. adjoint gradient computation times and ratios for the non stationary case. \label{tab:nonstat}}
\begin{tabular}{lrll}
 & Direct & Adjoint & Ratio\\
 \hline\\
Reduced network\\
 \hline
State computation \eqref{eq:discrcasc}& {\color{blue}21} & {\color{blue}21}& 1\\
Cascade \eqref{eq:discrdirect} vs. \eqref{eq:discradjoint}&{\color{blue}948} &  {\color{blue}15}& {\color{blue}60}\\
Gradient assembly  \eqref{eq:discrdirectgrad} vs. \eqref{eq:discradjgrad}& {\color{blue}11} & {\color{blue}16}& {\color{blue}0.70}\\
Total & {\color{blue}980} & {\color{blue}53} & {\color{blue}18.4}\\

\hline\\
\scriptsize{Unit time=$10^{-3}$  s.}
\end{tabular}
\end{table}

{\color{blue} We propose to generate synthetic data: from the estimated flux values obtained after optimizing real stationary measurements and from given pool size values including pool size measurements available in \cite{millard2014sampling}, non stationary data are produced by solving~\eqref{eq:discrcasc} for a collection~$\tau_j, j=1,\ldots ,M$ of time measurements. Gaussian noise is added by considering the values of standard deviations of each stationary measurement.

From this collection of synthetic data coupled with initial flux and pool size values, optimization is performed, which provides estimations of fluxes and pool sizes based on non stationary data. We are first interested in checking wether the time dependent measurements are best fit. %From the estimated parameter values, 
Simulated data are produced from the estimated parameter values at each node of the time grid and Figure~\ref{fig:meas} shows the time evolution of those data involving the metabolite Fru6P. 

Note that the set of measured pool sizes provided in~\cite{millard2014sampling} contain the Fru6P pool size value, so that the kinetics of the curves presented in Figure~\ref{fig:meas} has a realistic basis. Comparing these simulated data with the different time measurements involving Fru6P, marked with circles, demonstrates that synthetic data are well recovered by the collection of simulated measurements. %based on the estimated values (after optimization) of the parameters.

\begin{figure}
\includegraphics[scale=0.5]{etm_1_10_noise_fv_meas_fwd}
\caption{Time measurement reconstruction by simulated data after optimization of the parameters} 
\label{fig:meas}
\end{figure}
The estimated flux values obtained from non stationary data are reported in table~\ref{tab:flux} and opposed to the stationary flux estimations used to generate the time dependent data. Standard deviations related to each estimation are computed by the squared norm, up to the Fisher matrix, of the differentiation of the time measurements with respect to the parameters.

\begin{table}
\caption{Non stationary vs. stationary estimation of flux parameters}
\label{tab:flux}
\begin{center}
\begin{tabular}{l|c|l}
Non stationary&Flux&Stationary\\
\hline
$\times 10^{-2}$&&$\times 10^{-2}$\\
$81\pm  0.3$ &Glucupt\_1&$81\pm 0.6$\\
$66\pm 7$ &ald& $72\pm 15$\\
$10^5\pm \infty$ &eno& $10^5\pm \infty$\\
$154 \pm 31$ &pyk& $154\pm 22$\\
$15\pm 3.5$ &zwf& $14\pm 5.5$\\
$15 \pm 1.6$&gnd&$14\pm 4.9$\\
$57 \pm 3.2$ &ta& $57\pm 6.8$\\
$19 \pm 3.5$ &tk1&$18\pm 9.2$\\
$0\pm 1.5$ &tk2&$0\pm 5.2$\\
$9\pm 29$&fum\_a&$43\pm 110$\\
$23\pm 15$&ppc&$17\pm 13$\\
$21\pm 0.016$&out\_Ac&$21\pm 0.017$\\
\end{tabular}
\end{center}
\end{table}

We first note that the estimated values obtained from time dependent data are similar with those obtained from the stationary state. Then, focusing on the standard deviations shows that considering ten measurements during the non stationary state enables to have a better accuracy than using a single measurement when the stationary state is reached, which is of interest in experimental designs to fix the number of non stationary measurements.

If we now compare the computational time required for both direct and adjoint methods, estimations of the flux and pool size parameters take 468s by the direct method, while the optimization terminates after 21s by the adjoint method, which demonstrates the efficiency of the approach. }
%{Flux identification is based on the optimization of \eqref{eq:data} performed by the computation of the residual and of the gradient at each step of the iterative process.}

\section{Conclusion}
In this paper we address the MFA problem by adjoint state in the spirit of a general optimization problem governed by a state equation, as in control theory. In the stationary case, results demonstrate the efficiency of the approach in terms of precision and computational time when a typical metabolic network is considered and estimated values were validated against those obtained by other reference software. Due to the adjoint framework, only vectors (instead of matrices) are updated, which considerably speeds up the computation of the gradient. In the non-stationary case, we have considered the same network and a simple discrete time integration scheme. The state and gradient computation terminates in moderate time (less than 1s), which makes the non-stationary MFA problem computationally tractable. 

The software Sysmetab, distributed under OpenSource license, already implements the adjoint approach for stationary MFA and uses the same input format as 13CFlux2 software. Our current developments will allow Sysmetab to handle non-stationary MFA up to free fluxes, scaling factors and pool sizes estimation, considering high-order ODE solvers and automatic code generation. 
\section*{Acknowledgement}
%The authors wish to thank S. Sokol  (MetaSys team of LISBP Laboratory, Toulouse, France) for fruitful discussion and valuable suggestions.
%\paragraph{Funding}
This work was performed, in partnership with the SAS PIVERT, within the frame of the French Institute for the Energy Transition (Institut pour la Transition Energ\'etique - ITE) P.I.V.E.R.T. (www.institut-pivert.com) selected as an Investment for the Future ("Investissements d'Avenir"). This  work was supported, as part of the Investments for the Future, by the French Government under the reference ANR-001-01





% Can use something like this to put references on a page
% by themselves when using endfloat and the captionsoff option.
\ifCLASSOPTIONcaptionsoff
  \newpage
\fi



% trigger a \newpage just before the given reference
% number - used to balance the columns on the last page
% adjust value as needed - may need to be readjusted if
% the document is modified later
%\IEEEtriggeratref{8}
% The "triggered" command can be changed if desired:
%\IEEEtriggercmd{\enlargethispage{-5in}}

% references section

% can use a bibliography generated by BibTeX as a .bbl file
% BibTeX documentation can be easily obtained at:
% http://www.ctan.org/tex-archive/biblio/bibtex/contrib/doc/
% The IEEEtran BibTeX style support page is at:
% http://www.michaelshell.org/tex/ieeetran/bibtex/
%\bibliographystyle{IEEEtran}
% argument is your BibTeX string definitions and bibliography database(s)
%\bibliography{IEEEabrv,../bib/paper}
%
% <OR> manually copy in the resultant .bbl file
% set second argument of \begin to the number of references
% (used to reserve space for the reference number labels box)

\bibliographystyle{IEEEtran}
%\bibliographystyle{achemnat}
%\bibliographystyle{plainnat}
%\bibliographystyle{abbrv}
%\bibliographystyle{bioinformatics}
%
%\bibliographystyle{plain}
%
%\nocite{*}
%\bibliography{sysmetab}



% Generated by IEEEtran.bst, version: 1.13 (2008/09/30)
\begin{thebibliography}{10}
\providecommand{\url}[1]{#1}
\csname url@samestyle\endcsname
\providecommand{\newblock}{\relax}
\providecommand{\bibinfo}[2]{#2}
\providecommand{\BIBentrySTDinterwordspacing}{\spaceskip=0pt\relax}
\providecommand{\BIBentryALTinterwordstretchfactor}{4}
\providecommand{\BIBentryALTinterwordspacing}{\spaceskip=\fontdimen2\font plus
\BIBentryALTinterwordstretchfactor\fontdimen3\font minus
  \fontdimen4\font\relax}
\providecommand{\BIBforeignlanguage}[2]{{%
\expandafter\ifx\csname l@#1\endcsname\relax
\typeout{** WARNING: IEEEtran.bst: No hyphenation pattern has been}%
\typeout{** loaded for the language `#1'. Using the pattern for}%
\typeout{** the default language instead.}%
\else
\language=\csname l@#1\endcsname
\fi
#2}}
\providecommand{\BIBdecl}{\relax}
\BIBdecl

\bibitem{wiechert2013NMFA}
W.~Wiechert and K.~N{\"o}h, ``Isotopically non-stationary metabolic flux
  analysis: complex yet highly informative,'' \emph{Current opinion in
  biotechnology}, vol.~24, no.~6, pp. 979--986, 2013.

\bibitem{young2008elementary}
J.~D. Young, J.~L. Walther, M.~R. Antoniewicz, H.~Yoo, and G.~Stephanopoulos,
  ``An elementary metabolite unit ({EMU}) based method of isotopically
  nonstationary flux analysis,'' \emph{Biotechnology and bioengineering},
  vol.~99, no.~3, pp. 686--699, 2008.

\bibitem{young2014inca}
J.~D. Young, ``{INCA}: a computational platform for isotopically non-stationary
  metabolic flux analysis,'' \emph{Bioinformatics}, vol.~30, no.~9, pp.
  1333--1335, 2014.

\bibitem{openmoebius}
S.~Kajihata, C.~Furusawa, F.~Matsuda, and H.~Shimizu, ``{OpenMebius}: {A}n open
  source software for isotopically nonstationary {13 C}-based metabolic flux
  analysis,'' \emph{BioMed research international}, vol. 2014, no. 627014,
  2014.

\bibitem{Mottelet2012RR}
S.~Mottelet, ``Fast computation of gradient and sentitivity in {13C} metabolic
  flux analysis instationary experiments using the adjoint method,''
  \url{http://arxiv.org/abs/1206.5072}, 2012.

\bibitem{lionsmagenes}
J.~L. Lions and E.~Magenes, \emph{Non-homogeneous boundary value problems and
  applications}.\hskip 1em plus 0.5em minus 0.4em\relax Springer-Verlag,
  Berlin, New York, 1972.

\bibitem{chavent}
G.~Chavent, ``Identification of function parameters in partial differential
  equations,'' in \emph{Identification of parameter distributed systems},
  R.~Goodson and N.-Y. Polis, Eds.\hskip 1em plus 0.5em minus 0.4em\relax ASME,
  1974.

\bibitem{plessix}
R.-E. Plessix, ``A review of the adjoint-state method for computing the
  gradient of a functional with geophysical applications,'' \emph{Geophysical
  Journal International}, vol. 167, pp. 495--503, 2006.

\bibitem{wiechert1}
W.~Wiechert and M.~Wurzel, ``Metabolic isotopomer labeling systems: Part {I}:
  global dynamic behavior,'' \emph{Mathematical Biosciences}, vol. 169, no.~2,
  pp. 173 -- 205, 2001.

\bibitem{influxs}
\BIBentryALTinterwordspacing
S.~Sokol, P.~Millard, and J.~Portais, ``influx{\_}s: increasing numerical
  stability and precision for metabolic flux analysis in isotope labelling
  experiments,'' \emph{Bioinformatics}, vol.~28, no.~5, pp. 687--693, 2012.
  [Online]. Available: \url{http://dx.doi.org/10.1093/bioinformatics/btr716}
\BIBentrySTDinterwordspacing

\bibitem{sandu}
\BIBentryALTinterwordspacing
A.~Sandu and P.~Miehe, ``Forward, tangent linear, and adjoint {Runge–Kutta}
  methods for stiff chemical kinetic simulations,'' \emph{International Journal
  of Computer Mathematics}, vol.~87, no.~11, pp. 2458--2479, 2010. [Online].
  Available: \url{http://dx.doi.org/10.1080/00207160802676562}
\BIBentrySTDinterwordspacing

\bibitem{13CFLUX2}
\BIBentryALTinterwordspacing
M.~Weitzel, K.~N{\"o}h, T.~Dalman, S.~Niedenf¸hr, B.~Stute, and W.~Wiechert,
  ``{13CFLUX2} - high-performance software suite for {13C}-metabolic flux
  analysis.'' \emph{Bioinformatics}, vol.~29, no.~1, pp. 143--145, 2013.
  [Online]. Available:
  \url{http://dblp.uni-trier.de/db/journals/bioinformatics/bioinformatics29.html#WeitzelNDNSW13}
\BIBentrySTDinterwordspacing

\bibitem{scilabbook}
C.~Bunks, J.~Chancelier, F.~Delebecque, C.~Gomez, M.~Goursat, R.~Nikoukhah, and
  S.~Steer, \emph{Engineering and Scientific Computing with Scilab}.\hskip 1em
  plus 0.5em minus 0.4em\relax Birka\"user, Boston, 1999.

\bibitem{antoniewicz2007}
M.~R. Antoniewicz, J.~K. Kelleher, and G.~Stephanopoulos, ``Elementary
  metabolite units ({EMU}): a novel framework for modeling isotopic
  distributions,'' \emph{Metabolic engineering}, vol.~9, no.~1, pp. 68--86,
  2007.

\bibitem{davis:umfpack}
\BIBentryALTinterwordspacing
T.~A. Davis, ``{Algorithm 832: {UMFPACK V4.3}---an unsymmetric-pattern
  multifrontal method},'' \emph{ACM Transactions On Mathematical Software},
  vol.~30, no.~2, pp. 196--199, Jun. 2004. [Online]. Available:
  \url{http://dx.doi.org/10.1145/992200.992206}
\BIBentrySTDinterwordspacing

\bibitem{fsqp}
C.~T. Lawrence and A.~L. Tits, ``A computationally efficient feasible
  sequential quadratic programming algorithm,'' \emph{SIAM Journal on
  Optimization}, vol.~11, pp. 1092--1118, 2001.

\bibitem{millard2014sampling}
P.~Millard, S.~Massou, C.~Wittmann, J.-C. Portais, and F.~L{\'e}tisse,
  ``Sampling of intracellular metabolites for stationary and non-stationary {13
  C} metabolic flux analysis in {Escherichia coli},'' \emph{Analytical
  biochemistry}, vol. 465, pp. 38--49, 2014.

\end{thebibliography}





% biography section
% 
% If you have an EPS/PDF photo (graphicx package needed) extra braces are
% needed around the contents of the optional argument to biography to prevent
% the LaTeX parser from getting confused when it sees the complicated
% \includegraphics command within an optional argument. (You could create
% your own custom macro containing the \includegraphics command to make things
% simpler here.)
%\begin{IEEEbiography}[{\includegraphics[width=1in,height=1.25in,clip,keepaspectratio]{mshell}}]{Michael Shell}
% or if you just want to reserve a space for a photo:

\begin{IEEEbiography}{St\'ephane Mottelet}
Biography text here.
\end{IEEEbiography}

% if you will not have a photo at all:
\begin{IEEEbiography}{Gil Gaullier}
%\begin{IEEEbiographynophoto}{Gil Gaullier}
Biography text here.
%\end{IEEEbiographynophoto}
\end{IEEEbiography}

% insert where needed to balance the two columns on the last page with
% biographies
%\newpage

\begin{IEEEbiography}{Georges Sadaka}
%\begin{IEEEbiographynophoto}{Georges Sadaka}
Biography text here.
%\end{IEEEbiographynophoto}
\end{IEEEbiography}

% You can push biographies down or up by placing
% a \vfill before or after them. The appropriate
% use of \vfill depends on what kind of text is
% on the last page and whether or not the columns
% are being equalized.

%\vfill

% Can be used to pull up biographies so that the bottom of the last one
% is flush with the other column.
%\enlargethispage{-5in}



% that's all folks
\end{document}


